﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DevLeap.Linq.LinqToEntitiesPOCO;
using System.Data.Objects;
using System.Configuration;
using DevLeap.Linq.Entities;

namespace DevLeap.Linq.EFPOCOConsumer
{
    class Program
    {
        static void Main(string[] args)
        {
            EF4SampleDBEntities ctx = new EF4SampleDBEntities(ConfigurationManager.ConnectionStrings["EF4SampleDBEntities"].ConnectionString);

            var customers =
                from c in ctx.Contacts.OfType<Customer>() // .Include("Orders")
                select c;

            foreach (var c in customers)
            {
                Console.WriteLine("Customer {0} has ID {1}, with an income of {2} last year",
                    c.FullName, c.ContactID, c.LastYearIncomes);

                foreach (var o in c.Orders)
                {
                    Console.WriteLine("Order ID: {0}\nCreated: {1} - Shipped: {2}\nEuro Amount: {3:c}",
                        o.OrderID, o.CreationDateTime, 
                        o.ShippingDateTime, o.EuroAmount);
                }
            }

            var firstCustomer = ctx.Contacts.OfType<Customer>().FirstOrDefault();

            firstCustomer.EMail = "changed!";

            ctx.SaveChanges();
        }
    }
}
