﻿/* Listing 9-4 */
SELECT 
[Extent1].[CustomerID] AS [CustomerID], 
[Extent1].[CompanyName] AS [CompanyName], 
[Extent1].[ContactName] AS [ContactName], 
[Extent1].[ContactTitle] AS [ContactTitle], 
[Extent1].[Address] AS [Address], 
[Extent1].[City] AS [City], 
[Extent1].[Region] AS [Region], 
[Extent1].[PostalCode] AS [PostalCode], 
[Extent1].[Country] AS [Country], 
[Extent1].[Phone] AS [Phone], 
[Extent1].[Fax] AS [Fax]
FROM [dbo].[Customers] AS [Extent1]
WHERE N'Italy' = [Extent1].[Country]

/* Listing 9-5 */
exec sp_executesql N'SELECT 
[Extent1].[CustomerID] AS [CustomerID], 
[Extent1].[CompanyName] AS [CompanyName], 
[Extent1].[ContactName] AS [ContactName], 
[Extent1].[ContactTitle] AS [ContactTitle], 
[Extent1].[Address] AS [Address], 
[Extent1].[City] AS [City], 
[Extent1].[Region] AS [Region], 
[Extent1].[PostalCode] AS [PostalCode], 
[Extent1].[Country] AS [Country], 
[Extent1].[Phone] AS [Phone], 
[Extent1].[Fax] AS [Fax]
FROM [dbo].[Customers] AS [Extent1]
WHERE [Extent1].[Country] = @p__linq__0',N'@p__linq__0 nvarchar(4000)',@p__linq__0=N'Italy'

/* Listing 9-10 */
exec sp_executesql N'SELECT 
[Extent2].[OrderID] AS [OrderID], 
[Extent2].[OrderDate] AS [OrderDate]
FROM  [dbo].[Customers] AS [Extent1]
INNER JOIN [dbo].[Orders] AS [Extent2] ON [Extent1].[CustomerID] = [Extent2].[CustomerID]
WHERE ([Extent1].[Country] = @p__linq__0) AND ((DATEDIFF (day, [Extent2].[OrderDate], SysDateTime())) <= 7)',N'@p__linq__0 nvarchar(4000)',@p__linq__0=N'Italy'

/* Listing 9-12 */
exec sp_executesql N'SELECT 
[Extent2].[OrderID] AS [OrderID], 
[Extent2].[OrderDate] AS [OrderDate]
FROM  [dbo].[Customers] AS [Extent1]
INNER JOIN [dbo].[Orders] AS [Extent2] ON [Extent1].[CustomerID] = [Extent2].[CustomerID]
WHERE ([Extent1].[Country] = @p__linq__0) AND ((DATEADD(day, cast(7 as float(53)), [Extent2].[OrderDate])) >= (GETDATE()))',N'@p__linq__0 nvarchar(4000)',@p__linq__0=N'Italy'

/* Listing 9-13 */
USE [Northwind]
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION [dbo].[TotalOrdersAmount](@CustomerID nchar(5))
RETURNS MONEY
AS
	BEGIN
	DECLARE @total MONEY;
	SELECT @total = SUM(od.UnitPrice * od.Quantity)
		FROM Customers AS c 
		INNER JOIN Orders AS o ON c.CustomerID = o.CustomerID
		INNER JOIN [Order Details] AS od ON od.OrderID = o.OrderID
		WHERE c.CustomerID = @CustomerID
		GROUP BY c.CustomerID
	RETURN @total;
END

/* Listing 9-16 */
SELECT TOP (5) 
[Project1].[C2] AS [C1], 
[Project1].[CustomerID] AS [CustomerID], 
[Project1].[CompanyName] AS [CompanyName]
FROM ( SELECT 
	[dbo].[TotalOrdersAmount]([Extent1].[CustomerID]) AS [C1], 
	[Extent1].[CustomerID] AS [CustomerID], 
	[Extent1].[CompanyName] AS [CompanyName], 
	1 AS [C2]
	FROM [dbo].[Customers] AS [Extent1]
)  AS [Project1]
ORDER BY [Project1].[C1] DESC

/* Listing 9-19 */
SELECT 
[Extent1].[CustomerID] AS [CustomerID], 
[Extent1].[CompanyName] AS [CompanyName], 
[Extent1].[ContactName] AS [ContactName], 
[Extent1].[ContactTitle] AS [ContactTitle], 
[Extent1].[Address] AS [Address], 
[Extent1].[City] AS [City], 
[Extent1].[Region] AS [Region], 
[Extent1].[PostalCode] AS [PostalCode], 
[Extent1].[Country] AS [Country], 
[Extent1].[Phone] AS [Phone], 
[Extent1].[Fax] AS [Fax]
FROM [dbo].[Customers] AS [Extent1]

/* Listing 9-20 */
exec sp_executesql N'SELECT 
[Extent1].[OrderID] AS [OrderID], 
[Extent1].[CustomerID] AS [CustomerID], 
[Extent1].[EmployeeID] AS [EmployeeID], 
[Extent1].[OrderDate] AS [OrderDate], 
[Extent1].[RequiredDate] AS [RequiredDate], 
[Extent1].[ShippedDate] AS [ShippedDate], 
[Extent1].[ShipVia] AS [ShipVia], 
[Extent1].[Freight] AS [Freight], 
[Extent1].[ShipName] AS [ShipName], 
[Extent1].[ShipAddress] AS [ShipAddress], 
[Extent1].[ShipCity] AS [ShipCity], 
[Extent1].[ShipRegion] AS [ShipRegion], 
[Extent1].[ShipPostalCode] AS [ShipPostalCode], 
[Extent1].[ShipCountry] AS [ShipCountry]
FROM [dbo].[Orders] AS [Extent1]
WHERE [Extent1].[CustomerID] = @EntityKeyValue1',N'@EntityKeyValue1 nchar(5)',@EntityKeyValue1=N'ALFKI'

/* Listing 9-22 */
SELECT 
[Project1].[C1] AS [C1], 
[Project1].[CustomerID] AS [CustomerID], 
[Project1].[CompanyName] AS [CompanyName], 
[Project1].[ContactName] AS [ContactName], 
[Project1].[ContactTitle] AS [ContactTitle], 
[Project1].[Address] AS [Address], 
[Project1].[City] AS [City], 
[Project1].[Region] AS [Region], 
[Project1].[PostalCode] AS [PostalCode], 
[Project1].[Country] AS [Country], 
[Project1].[Phone] AS [Phone], 
[Project1].[Fax] AS [Fax], 
[Project1].[C2] AS [C2], 
[Project1].[OrderID] AS [OrderID], 
[Project1].[CustomerID1] AS [CustomerID1], 
[Project1].[EmployeeID] AS [EmployeeID], 
[Project1].[OrderDate] AS [OrderDate], 
[Project1].[RequiredDate] AS [RequiredDate], 
[Project1].[ShippedDate] AS [ShippedDate], 
[Project1].[ShipVia] AS [ShipVia], 
[Project1].[Freight] AS [Freight], 
[Project1].[ShipName] AS [ShipName], 
[Project1].[ShipAddress] AS [ShipAddress], 
[Project1].[ShipCity] AS [ShipCity], 
[Project1].[ShipRegion] AS [ShipRegion], 
[Project1].[ShipPostalCode] AS [ShipPostalCode], 
[Project1].[ShipCountry] AS [ShipCountry]
FROM ( SELECT 
	[Extent1].[CustomerID] AS [CustomerID], 
	[Extent1].[CompanyName] AS [CompanyName], 
	[Extent1].[ContactName] AS [ContactName], 
	[Extent1].[ContactTitle] AS [ContactTitle], 
	[Extent1].[Address] AS [Address], 
	[Extent1].[City] AS [City], 
	[Extent1].[Region] AS [Region], 
	[Extent1].[PostalCode] AS [PostalCode], 
	[Extent1].[Country] AS [Country], 
	[Extent1].[Phone] AS [Phone], 
	[Extent1].[Fax] AS [Fax], 
	1 AS [C1], 
	[Extent2].[OrderID] AS [OrderID], 
	[Extent2].[CustomerID] AS [CustomerID1], 
	[Extent2].[EmployeeID] AS [EmployeeID], 
	[Extent2].[OrderDate] AS [OrderDate], 
	[Extent2].[RequiredDate] AS [RequiredDate], 
	[Extent2].[ShippedDate] AS [ShippedDate], 
	[Extent2].[ShipVia] AS [ShipVia], 
	[Extent2].[Freight] AS [Freight], 
	[Extent2].[ShipName] AS [ShipName], 
	[Extent2].[ShipAddress] AS [ShipAddress], 
	[Extent2].[ShipCity] AS [ShipCity], 
	[Extent2].[ShipRegion] AS [ShipRegion], 
	[Extent2].[ShipPostalCode] AS [ShipPostalCode], 
	[Extent2].[ShipCountry] AS [ShipCountry], 
	CASE WHEN ([Extent2].[OrderID] IS NULL) THEN CAST(NULL AS int) ELSE 1 END AS [C2]
	FROM  [dbo].[Customers] AS [Extent1]
	LEFT OUTER JOIN [dbo].[Orders] AS [Extent2] ON [Extent1].[CustomerID] = [Extent2].[CustomerID]
)  AS [Project1]
ORDER BY [Project1].[CustomerID] ASC, [Project1].[C2] ASC

/* Listing 9-xx */
SELECT 
[Project1].[C1] AS [C1], 
[Project1].[CustomerID] AS [CustomerID], 
[Project1].[CompanyName] AS [CompanyName], 
[Project1].[ContactName] AS [ContactName], 
[Project1].[ContactTitle] AS [ContactTitle], 
[Project1].[Address] AS [Address], 
[Project1].[City] AS [City], 
[Project1].[Region] AS [Region], 
[Project1].[PostalCode] AS [PostalCode], 
[Project1].[Country] AS [Country], 
[Project1].[Phone] AS [Phone], 
[Project1].[Fax] AS [Fax], 
[Project1].[C3] AS [C2], 
[Project1].[OrderID] AS [OrderID], 
[Project1].[CustomerID1] AS [CustomerID1], 
[Project1].[EmployeeID] AS [EmployeeID], 
[Project1].[OrderDate] AS [OrderDate], 
[Project1].[RequiredDate] AS [RequiredDate], 
[Project1].[ShippedDate] AS [ShippedDate], 
[Project1].[ShipVia] AS [ShipVia], 
[Project1].[Freight] AS [Freight], 
[Project1].[ShipName] AS [ShipName], 
[Project1].[ShipAddress] AS [ShipAddress], 
[Project1].[ShipCity] AS [ShipCity], 
[Project1].[ShipRegion] AS [ShipRegion], 
[Project1].[ShipPostalCode] AS [ShipPostalCode], 
[Project1].[ShipCountry] AS [ShipCountry], 
[Project1].[C2] AS [C3], 
[Project1].[OrderID1] AS [OrderID1], 
[Project1].[ProductID] AS [ProductID], 
[Project1].[UnitPrice] AS [UnitPrice], 
[Project1].[Quantity] AS [Quantity], 
[Project1].[Discount] AS [Discount], 
[Project1].[ProductID1] AS [ProductID1], 
[Project1].[ProductName] AS [ProductName], 
[Project1].[SupplierID] AS [SupplierID], 
[Project1].[CategoryID] AS [CategoryID], 
[Project1].[QuantityPerUnit] AS [QuantityPerUnit], 
[Project1].[UnitPrice1] AS [UnitPrice1], 
[Project1].[UnitsInStock] AS [UnitsInStock], 
[Project1].[UnitsOnOrder] AS [UnitsOnOrder], 
[Project1].[ReorderLevel] AS [ReorderLevel], 
[Project1].[Discontinued] AS [Discontinued]
FROM ( SELECT 
	[Extent1].[CustomerID] AS [CustomerID], 
	[Extent1].[CompanyName] AS [CompanyName], 
	[Extent1].[ContactName] AS [ContactName], 
	[Extent1].[ContactTitle] AS [ContactTitle], 
	[Extent1].[Address] AS [Address], 
	[Extent1].[City] AS [City], 
	[Extent1].[Region] AS [Region], 
	[Extent1].[PostalCode] AS [PostalCode], 
	[Extent1].[Country] AS [Country], 
	[Extent1].[Phone] AS [Phone], 
	[Extent1].[Fax] AS [Fax], 
	1 AS [C1], 
	[Join2].[OrderID1] AS [OrderID], 
	[Join2].[CustomerID] AS [CustomerID1], 
	[Join2].[EmployeeID] AS [EmployeeID], 
	[Join2].[OrderDate] AS [OrderDate], 
	[Join2].[RequiredDate] AS [RequiredDate], 
	[Join2].[ShippedDate] AS [ShippedDate], 
	[Join2].[ShipVia] AS [ShipVia], 
	[Join2].[Freight] AS [Freight], 
	[Join2].[ShipName] AS [ShipName], 
	[Join2].[ShipAddress] AS [ShipAddress], 
	[Join2].[ShipCity] AS [ShipCity], 
	[Join2].[ShipRegion] AS [ShipRegion], 
	[Join2].[ShipPostalCode] AS [ShipPostalCode], 
	[Join2].[ShipCountry] AS [ShipCountry], 
	[Join2].[OrderID2] AS [OrderID1], 
	[Join2].[ProductID1] AS [ProductID], 
	[Join2].[UnitPrice1] AS [UnitPrice], 
	[Join2].[Quantity] AS [Quantity], 
	[Join2].[Discount] AS [Discount], 
	[Join2].[ProductID2] AS [ProductID1], 
	[Join2].[ProductName] AS [ProductName], 
	[Join2].[SupplierID] AS [SupplierID], 
	[Join2].[CategoryID] AS [CategoryID], 
	[Join2].[QuantityPerUnit] AS [QuantityPerUnit], 
	[Join2].[UnitPrice2] AS [UnitPrice1], 
	[Join2].[UnitsInStock] AS [UnitsInStock], 
	[Join2].[UnitsOnOrder] AS [UnitsOnOrder], 
	[Join2].[ReorderLevel] AS [ReorderLevel], 
	[Join2].[Discontinued] AS [Discontinued], 
	CASE WHEN ([Join2].[OrderID1] IS NULL) THEN CAST(NULL AS int) WHEN ([Join2].[OrderID2] IS NULL) THEN CAST(NULL AS int) ELSE 1 END AS [C2], 
	CASE WHEN ([Join2].[OrderID1] IS NULL) THEN CAST(NULL AS int) ELSE 1 END AS [C3]
	FROM  [dbo].[Customers] AS [Extent1]
	LEFT OUTER JOIN  (SELECT [Extent2].[OrderID] AS [OrderID1], [Extent2].[CustomerID] AS [CustomerID], [Extent2].[EmployeeID] AS [EmployeeID], [Extent2].[OrderDate] AS [OrderDate], [Extent2].[RequiredDate] AS [RequiredDate], [Extent2].[ShippedDate] AS [ShippedDate], [Extent2].[ShipVia] AS [ShipVia], [Extent2].[Freight] AS [Freight], [Extent2].[ShipName] AS [ShipName], [Extent2].[ShipAddress] AS [ShipAddress], [Extent2].[ShipCity] AS [ShipCity], [Extent2].[ShipRegion] AS [ShipRegion], [Extent2].[ShipPostalCode] AS [ShipPostalCode], [Extent2].[ShipCountry] AS [ShipCountry], [Join1].[OrderID2], [Join1].[ProductID1], [Join1].[UnitPrice1], [Join1].[Quantity], [Join1].[Discount], [Join1].[ProductID2], [Join1].[ProductName], [Join1].[SupplierID], [Join1].[CategoryID], [Join1].[QuantityPerUnit], [Join1].[UnitPrice2], [Join1].[UnitsInStock], [Join1].[UnitsOnOrder], [Join1].[ReorderLevel], [Join1].[Discontinued]
		FROM  [dbo].[Orders] AS [Extent2]
		LEFT OUTER JOIN  (SELECT [Extent3].[OrderID] AS [OrderID2], [Extent3].[ProductID] AS [ProductID1], [Extent3].[UnitPrice] AS [UnitPrice1], [Extent3].[Quantity] AS [Quantity], [Extent3].[Discount] AS [Discount], [Extent4].[ProductID] AS [ProductID2], [Extent4].[ProductName] AS [ProductName], [Extent4].[SupplierID] AS [SupplierID], [Extent4].[CategoryID] AS [CategoryID], [Extent4].[QuantityPerUnit] AS [QuantityPerUnit], [Extent4].[UnitPrice] AS [UnitPrice2], [Extent4].[UnitsInStock] AS [UnitsInStock], [Extent4].[UnitsOnOrder] AS [UnitsOnOrder], [Extent4].[ReorderLevel] AS [ReorderLevel], [Extent4].[Discontinued] AS [Discontinued]
			FROM  [dbo].[Order Details] AS [Extent3]
			INNER JOIN [dbo].[Products] AS [Extent4] ON [Extent3].[ProductID] = [Extent4].[ProductID] ) AS [Join1] ON [Extent2].[OrderID] = [Join1].[OrderID2] ) AS [Join2] ON [Extent1].[CustomerID] = [Join2].[CustomerID]
)  AS [Project1]
ORDER BY [Project1].[CustomerID] ASC, [Project1].[C3] ASC, [Project1].[OrderID] ASC, [Project1].[C2] ASC
