﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Text;
using System.IO;
using System.Xml;


namespace DevLeap.Linq.LinqToSql.XmlMapping {
/* Class Customer decorated with attributes
    [Table(Name = "Customers")]
    public class Customer {
        [Column(IsPrimaryKey = true)]
        public string CustomerID;
        [Column]
        public string CompanyName;
        [Column]
        public string City;
        [Column(Name = "Region")]
        public string State;
        [Column]
        public string Country;
    }
*/

    //
    // Listing 6-14
    //
    public class Customer {
        public string CustomerID;
        public string CompanyName;
        public string City;
        public string State;
        public string Country;
    }

    public class Northwind : DataContext {
        public Northwind(string connection) :
            this(connection, GetMapping()) { }

        public Northwind(string connection, MappingSource mapping) :
            base(connection, mapping) { }

        static MappingSource GetMapping() {
            using (StreamReader reader = new StreamReader("Northwind.xml")) {
                return XmlMappingSource.FromReader(new XmlTextReader(reader));
            }
        }

        public System.Data.Linq.Table<Customer> Customers {
            get { return this.GetTable<Customer>(); }
        }

    }

    //
    // Listing 6-15
    //
    public class XmlMapping {
        public static void SimpleQuery() {
            Northwind db = new Northwind(Connections.ConnectionString);
            var query = from c in db.Customers
                        where c.City == "Seattle"
                            select c;

            foreach( var customer in query ) {
                Console.WriteLine(
                    "Customer={0}, State={1}",
                    customer.CompanyName, 
                    customer.State);
            }
        }
    }
}
