﻿Imports System.Xml.Linq
Imports System.Linq
Imports <xmlns:c="http://schemas.devleap.com/Customer">

Public Class Program

    Public Shared Sub Main()

        'Chapter 12
        'SampleXmlLiterals()
        'SampleXmlLiteralsToBuildAnXElement()
        'FunctionalConstructionWithLinqToObjects()
        'NamespaceHandlingWithLinqToXml()
        'NamespaceWithPrefixWithLinqToXml()
        'GlobalXmlNamespaceSample()

        'Chapter 13
        'FunctionalConstructionAsXsltTransformation()

    End Sub

    Private Shared Function createCustomersList() As List(Of Customer)

        Dim customers As New List(Of Customer)

        Dim c As Customer

        c = New Customer()
        c.FirstName = "Paolo"
        c.LastName = "Pialorsi"
        c.Country = Countries.Italy
        customers.Add(c)

        c = New Customer()
        c.FirstName = "Marco"
        c.LastName = "Russo"
        c.Country = Countries.Italy
        customers.Add(c)

        c = New Customer()
        c.FirstName = "John"
        c.LastName = "White"
        c.Country = Countries.USA
        customers.Add(c)

        c = New Customer()
        c.FirstName = "Frank"
        c.LastName = "Green"
        c.Country = Countries.USA
        customers.Add(c)

        Return customers

    End Function


    '
    ' Listing 12-3
    '
    Private Shared Sub SampleXmlLiterals()

        Dim xCustomer As XDocument = _
          <?xml version="1.0" encoding="UTF-16" standalone="yes"?>
          <customer id="C01">
              <firstName>Paolo</firstName>
              <lastName>Pialorsi</lastName>
              <addresses>
                  <address type="email">paolo@devleap.it</address>
                  <address type="url">http://www.devleap.it/</address>
                  <address type="home">Brescia - Italy</address>
              </addresses>
          </customer>

        Console.WriteLine(xCustomer)
        Console.ReadLine()

        Dim address As XElement
        For Each address In xCustomer.<customer>.<addresses>.<address>
            Console.WriteLine(address.Value)
        Next
        Console.ReadLine()

    End Sub

    '
    ' Listing 12-6
    '
    Private Shared Sub SampleXmlLiteralsToBuildAnXElement()

        Dim customerName As String = "Paolo"
        Dim customerTag As XElement =
          <customer>
              <firstName><%= customerName %></firstName>
          </customer>

        Console.WriteLine(customerTag)
        Console.ReadLine()

    End Sub

    '
    ' Listing 12-13
    '
    Private Shared Sub FunctionalConstructionWithLinqToObjects()

        Dim customers As List(Of Customer) = createCustomersList()

        Dim xmlCustomers As XElement =
          <customers>
              <%= From c In customers _
                  Where (c.Country = Countries.Italy)
                  Select
                  <customer>
                      <firstName><%= c.FirstName %></firstName>
                  </customer> %>
          </customers>

        Console.WriteLine(xmlCustomers)
        Console.ReadLine()

    End Sub

    '
    ' Listing 12-16
    '
    Private Shared Sub NamespaceHandlingWithLinqToXml()

        Dim customer As XDocument =
          <?xml version="1.0" encoding="utf-8"?>
          <customer id="C01" xmlns="http://schemas.devleap.com/Customer">
              <firstName>Paolo</firstName>
              <lastName>Pialorsi</lastName>
          </customer>

        Console.WriteLine(customer)
        Console.ReadLine()

    End Sub

    '
    ' Listing 12-20
    '
    Private Shared Sub NamespaceWithPrefixWithLinqToXml()

        Dim customer As XDocument =
        <?xml version="1.0" encoding="utf-8"?>
        <c:customer xmlns:c="http://schemas.devleap.com/Customer" id="C01">
            <c:firstName>Paolo</c:firstName>
            <c:lastName>Pialorsi</c:lastName>
        </c:customer>

        Console.WriteLine(customer)
        Console.ReadLine()

    End Sub

    '
    ' Listing 12-21
    '
    Private Shared Sub GlobalXmlNamespaceSample()

        Dim xmlCustomers As XDocument =
        <?xml version="1.0" encoding="utf-8"?>
        <c:customers>
            <c:customer name="Paolo" city="Brescia" country="Italy"/>
            <c:customer name="Marco" city="Torino" country="Italy"/>
            <c:customer name="James" city="Dallas" country="USA"/>
            <c:customer name="Frank" city="Seattle" country="USA"/>
        </c:customers>

        Console.WriteLine(xmlCustomers.<c:customers>.<c:customer>.First().@name)
        Console.ReadLine()

    End Sub

    '
    ' Listing 13-21
    '
    Private Shared Sub FunctionalConstructionAsXsltTransformation()

        Dim sourceXmlCustomers As XDocument =
        <?xml version="1.0" encoding="utf-8"?>
        <customers>
            <customer name="Paolo" city="Brescia" country="Italy"/>
            <customer name="Marco" city="Torino" country="Italy"/>
            <customer name="James" city="Dallas" country="USA"/>
            <customer name="Frank" city="Seattle" country="USA"/>
        </customers>

        Dim destinationXmlCustomers =
        <c:customers xmlns:c="http://schemas.devleap.com/Customers">
            <%= From c In sourceXmlCustomers.<customers>.<customer>
                Where (c.@country = "Italy")
                Select
                <c:customer xmlns:c="http://schemas.devleap.com/Customers">
                    <c:name><%= c.@name %></c:name>
                    <c:city><%= c.@city %></c:city>
                </c:customer> %>
        </c:customers>

        Console.WriteLine(destinationXmlCustomers)
        Console.ReadLine()

    End Sub

End Class

Class Customer

    Public FirstName As String
    Public LastName As String
    Public Country As Countries

End Class

Public Enum Countries
    Italy
    USA
End Enum

